<!doctype html>
<html>

<head>
    <!--Step 2-->
    <script src="https://d3js.org/d3.v4.min.js"></script>
</head>

<body>
    <!--Step 2-->
    <svg width="500" height="400"></svg>
    <script>
        
        const apiURL = "http://127.0.0.1:8008/js/"
        const csvFile = "data.csv"

        function apiCallback(apiResponseData) {
            console.log("----CALLING API--")
            console.log(apiResponseData)
            _mainRenderer(apiResponseData)
        }

        function _mainRenderer(_nums) {
            var dataset1 = _nums
            // Step 3
            var svg = d3.select("svg"),
                margin = 200,
                width = svg.attr("width") - margin, //300
                height = svg.attr("height") - margin //200

            // Step 4 
            var xScale = d3.scaleLinear().domain([0, 70]).range([0, width]),
                yScale = d3.scaleLinear().domain([30, 300]).range([height, 0]);

            var g = svg.append("g")
                .attr("transform", "translate(" + 100 + "," + 100 + ")");

            // Step 5
            // Title
            svg.append('text')
                .attr('x', width / 2 + 100)
                .attr('y', 100)
                .attr('text-anchor', 'middle')
                .style('font-family', 'Helvetica')
                .style('font-size', 20)
                .text('Line Chart');

            // X label
            svg.append('text')
                .attr('x', width / 2 + 100)
                .attr('y', height - 15 + 150)
                .attr('text-anchor', 'middle')
                .style('font-family', 'Helvetica')
                .style('font-size', 12)
                .text('Independant');

            // Y label
            svg.append('text')
                .attr('text-anchor', 'middle')
                .attr('transform', 'translate(60,' + height + ')rotate(-90)')
                .style('font-family', 'Helvetica')
                .style('font-size', 12)
                .text('Dependant');

            // Step 6
            g.append("g")
                .attr("transform", "translate(0," + height + ")")
                .call(d3.axisBottom(xScale));

            g.append("g")
                .call(d3.axisLeft(yScale));

            // Step 7
            svg.append('g')
                .selectAll("dot")
                .data(dataset1)
                .enter()
                .append("circle")
                .attr("cx", function (d) { return xScale(d[0]); })
                .attr("cy", function (d) { return yScale(d[1]); })
                .attr("r", 3)
                .attr("transform", "translate(" + 100 + "," + 100 + ")")
                .style("fill", "#000000");

            // Step 8        
            var line = d3.line()
                .x(function (d) { return xScale(d[0]); })
                .y(function (d) { return yScale(d[1]); })
                .curve(d3.curveMonotoneX)

            svg.append("path")
                .datum(dataset1)
                .attr("class", "line")
                .attr("transform", "translate(" + 100 + "," + 100 + ")")
                .attr("d", line)
                .style("fill", "none")
                .style("stroke", "#CC0000")
                .style("stroke-width", "1");
        }

        // Load data from CSV
        function readCSV(){
        d3.csv(csvFile, function (error, data) {
            _nums = []
            if (error) throw error;
            // format the data
            data.forEach(function (d) {
                console.log([d.year, d.population])
                console.log(_nums)
                _nums.push([d.year, d.population])
            });
            _mainRenderer(_nums)
        },
        );
    };
        //  Load data from API
       function  readAPI() {
        d3.request(apiURL)
        .mimeType("application/json")
        .response(function(xhr) { return JSON.parse(xhr.responseText); })
        .get(apiCallback);
    }
    readCSV()
    readAPI()
    </script>
</body>

</html>